| Version: 3.3.1

Public Member Functions | List of all members
wxDDEConnection Class Reference
Class List by Category » Interprocess Communication

`#include <wx/dde.h>`

Inheritance diagram for wxDDEConnection:
[legend]

## Detailed Description

A wxDDEConnection object represents the connection between a client and a server.

It can be created by making a connection using a wxDDEClient object, or by the acceptance of a connection by a wxDDEServer object. The bulk of a DDE (Dynamic Data Exchange) conversation is controlled by calling members in a wxDDEConnection object or by overriding its members.

An application should normally derive a new connection class from wxDDEConnection, in order to override the communication event handlers to do something interesting.

This DDE-based implementation is available on Windows only, but a platform-independent, socket-based version of this API is available using wxTCPConnection.

##

Library: wxBase
Category: Interprocess Communication
Availability: only available for the wxMSW port.

See also
  wxConnectionBase, wxDDEClient, wxDDEServer, Interprocess Communication

## Public Member Functions
| wxDDEConnection ()
| Constructs a connection object. More...
| wxDDEConnection (void *buffer, size_t size)
| Constructs a connection object. More...
bool | Disconnect ()
| Called by the client or server application to disconnect from the other program; it causes the OnDisconnect() message to be sent to the corresponding connection object in the other program. More...
virtual bool | OnAdvise (const wxString &topic, const wxString &item, const void *data, size_t size, wxIPCFormat format)
| Message sent to the client application when the server notifies it of a change in the data associated with the given item. More...
virtual bool | OnDisconnect ()
| Message sent to the client or server application when the other application notifies it to delete the connection. More...
virtual bool | OnExecute (const wxString &topic, const void *data, size_t size, wxIPCFormat format)
| Message sent to the server application when the client notifies it to execute the given data. More...
virtual bool | OnPoke (const wxString &topic, const wxString &item, const void *data, size_t size, wxIPCFormat format)
| Message sent to the server application when the client notifies it to accept the given data. More...
virtual const void * | OnRequest (const wxString &topic, const wxString &item, size_t *size, wxIPCFormat format)
| Message sent to the server application when the client calls Request(). More...
virtual bool | OnStartAdvise (const wxString &topic, const wxString &item)
| Message sent to the server application by the client, when the client wishes to start an "advise loop" for the given topic and item. More...
virtual bool | OnStopAdvise (const wxString &topic, const wxString &item)
| Message sent to the server application by the client, when the client wishes to stop an "advise loop" for the given topic and item. More...
const void * | Request (const wxString &item, size_t *size, wxIPCFormat format=wxIPC_TEXT)
| Called by the client application to request data from the server. More...
bool | StartAdvise (const wxString &item)
| Called by the client application to ask if an advise loop can be started with the server. More...
bool | StopAdvise (const wxString &item)
| Called by the client application to ask if an advise loop can be stopped. More...
bool | Advise (const wxString &item, const void *data, size_t size, wxIPCFormat format=wxIPC_PRIVATE)
| Called by the server application to advise the client of a change in the data associated with the given item. More...
bool | Advise (const wxString &item, const char *data)
| Called by the server application to advise the client of a change in the data associated with the given item. More...
bool | Advise (const wxString &item, const wchar_t *data)
| Called by the server application to advise the client of a change in the data associated with the given item. More...
bool | Advise (const wxString &item, const wxString data)
| Called by the server application to advise the client of a change in the data associated with the given item. More...
bool | Execute (const void *data, size_t size, wxIPCFormat format=wxIPC_PRIVATE)
| Called by the client application to execute a command on the server. More...
bool | Execute (const char *data)
| Called by the client application to execute a command on the server. More...
bool | Execute (const wchar_t *data)
| Called by the client application to execute a command on the server. More...
bool | Execute (const wxString data)
| Called by the client application to execute a command on the server. More...
bool | Poke (const wxString &item, const void *data, size_t size, wxIPCFormat format=wxIPC_PRIVATE)
| Called by the client application to poke data into the server. More...
bool | Poke (const wxString &item, const char *data)
| Called by the client application to poke data into the server. More...
bool | Poke (const wxString &item, const wchar_t *data)
| Called by the client application to poke data into the server. More...
bool | Poke (const wxString &item, const wxString data)
| Called by the client application to poke data into the server. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxDDEConnection() [1/2]

wxDDEConnection::wxDDEConnection | ( |  | ) |

Constructs a connection object.

If no user-defined connection object is to be derived from wxDDEConnection, then the constructor should not be called directly, since the default connection object will be provided on requesting (or accepting) a connection. However, if the user defines his or her own derived connection object, the wxDDEServer::OnAcceptConnection() and/or wxDDEClient::OnMakeConnection() members should be replaced by functions which construct the new connection object.

A default buffer will be associated with this connection.

## ◆ wxDDEConnection() [2/2]

wxDDEConnection::wxDDEConnection | ( | void * | buffer,
|  | size_t | size
| ) |  |

Constructs a connection object.

If no user-defined connection object is to be derived from wxDDEConnection, then the constructor should not be called directly, since the default connection object will be provided on requesting (or accepting) a connection. However, if the user defines his or her own derived connection object, the wxDDEServer::OnAcceptConnection() and/or wxDDEClient::OnMakeConnection() members should be replaced by functions which construct the new connection object.

Parameters

  buffer | Buffer for this connection object to use in transactions.
  size | Size of the buffer given.

## Member Function Documentation

## ◆ Advise() [1/4]

bool wxDDEConnection::Advise | ( | const wxString & | item,
|  | const char * | data
| ) |  |

Called by the server application to advise the client of a change in the data associated with the given item.

Causes the client connection's OnAdvise() member to be called.

Returns
  true if successful.

## ◆ Advise() [2/4]

bool wxDDEConnection::Advise | ( | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format = `wxIPC_PRIVATE`
| ) |  |

Called by the server application to advise the client of a change in the data associated with the given item.

Causes the client connection's OnAdvise() member to be called.

Returns
  true if successful.

## ◆ Advise() [3/4]

bool wxDDEConnection::Advise | ( | const wxString & | item,
|  | const wchar_t * | data
| ) |  |

Called by the server application to advise the client of a change in the data associated with the given item.

Causes the client connection's OnAdvise() member to be called.

Returns
  true if successful.

## ◆ Advise() [4/4]

bool wxDDEConnection::Advise | ( | const wxString & | item,
|  | const wxString | data
| ) |  |

Called by the server application to advise the client of a change in the data associated with the given item.

Causes the client connection's OnAdvise() member to be called.

Returns
  true if successful.

## ◆ Disconnect()

bool wxDDEConnection::Disconnect | ( |  | ) |

Called by the client or server application to disconnect from the other program; it causes the OnDisconnect() message to be sent to the corresponding connection object in the other program.

The default behaviour of OnDisconnect() is to delete the connection, but the calling application must explicitly delete its side of the connection having called Disconnect().

Returns
  true if successful.

## ◆ Execute() [1/4]

bool wxDDEConnection::Execute | ( | const char * | data | ) |

Called by the client application to execute a command on the server.

Can also be used to transfer arbitrary data to the server (similar to Poke() in that respect). Causes the server connection's OnExecute() member to be called.

Returns
  true if successful.

## ◆ Execute() [2/4]

bool wxDDEConnection::Execute | ( | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format = `wxIPC_PRIVATE`
| ) |  |

Called by the client application to execute a command on the server.

Can also be used to transfer arbitrary data to the server (similar to Poke() in that respect). Causes the server connection's OnExecute() member to be called.

Returns
  true if successful.

## ◆ Execute() [3/4]

bool wxDDEConnection::Execute | ( | const wchar_t * | data | ) |

Called by the client application to execute a command on the server.

Can also be used to transfer arbitrary data to the server (similar to Poke() in that respect). Causes the server connection's OnExecute() member to be called.

Returns
  true if successful.

## ◆ Execute() [4/4]

bool wxDDEConnection::Execute | ( | const wxString | data | ) |

Called by the client application to execute a command on the server.

Can also be used to transfer arbitrary data to the server (similar to Poke() in that respect). Causes the server connection's OnExecute() member to be called.

Returns
  true if successful.

## ◆ OnAdvise()

virtual bool wxDDEConnection::OnAdvise | ( | const wxString & | topic,
|  | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the client application when the server notifies it of a change in the data associated with the given item.

## ◆ OnDisconnect()

virtual bool wxDDEConnection::OnDisconnect | ( |  | ) |
| virtual

Message sent to the client or server application when the other application notifies it to delete the connection.

Default behaviour is to delete the connection object.

## ◆ OnExecute()

virtual bool wxDDEConnection::OnExecute | ( | const wxString & | topic,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the server application when the client notifies it to execute the given data.

Note that there is no item associated with this message.

## ◆ OnPoke()

virtual bool wxDDEConnection::OnPoke | ( | const wxString & | topic,
|  | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the server application when the client notifies it to accept the given data.

## ◆ OnRequest()

virtual const void* wxDDEConnection::OnRequest | ( | const wxString & | topic,
|  | const wxString & | item,
|  | size_t * | size,
|  | wxIPCFormat | format
| ) |  |
| virtual

Message sent to the server application when the client calls Request().

The server should respond by returning a character string from OnRequest(), or nullptr to indicate no data.

## ◆ OnStartAdvise()

virtual bool wxDDEConnection::OnStartAdvise | ( | const wxString & | topic,
|  | const wxString & | item
| ) |  |
| virtual

Message sent to the server application by the client, when the client wishes to start an "advise loop" for the given topic and item.

The server can refuse to participate by returning false.

## ◆ OnStopAdvise()

virtual bool wxDDEConnection::OnStopAdvise | ( | const wxString & | topic,
|  | const wxString & | item
| ) |  |
| virtual

Message sent to the server application by the client, when the client wishes to stop an "advise loop" for the given topic and item.

The server can refuse to stop the advise loop by returning false, although this doesn't have much meaning in practice.

## ◆ Poke() [1/4]

bool wxDDEConnection::Poke | ( | const wxString & | item,
|  | const char * | data
| ) |  |

Called by the client application to poke data into the server.

Can be used to transfer arbitrary data to the server. Causes the server connection's OnPoke() member to be called.

Returns
  true if successful.

## ◆ Poke() [2/4]

bool wxDDEConnection::Poke | ( | const wxString & | item,
|  | const void * | data,
|  | size_t | size,
|  | wxIPCFormat | format = `wxIPC_PRIVATE`
| ) |  |

Called by the client application to poke data into the server.

Can be used to transfer arbitrary data to the server. Causes the server connection's OnPoke() member to be called.

Returns
  true if successful.

## ◆ Poke() [3/4]

bool wxDDEConnection::Poke | ( | const wxString & | item,
|  | const wchar_t * | data
| ) |  |

Called by the client application to poke data into the server.

Can be used to transfer arbitrary data to the server. Causes the server connection's OnPoke() member to be called.

Returns
  true if successful.

## ◆ Poke() [4/4]

bool wxDDEConnection::Poke | ( | const wxString & | item,
|  | const wxString | data
| ) |  |

Called by the client application to poke data into the server.

Can be used to transfer arbitrary data to the server. Causes the server connection's OnPoke() member to be called.

Returns
  true if successful.

## ◆ Request()

const void* wxDDEConnection::Request | ( | const wxString & | item,
|  | size_t * | size,
|  | wxIPCFormat | format = `wxIPC_TEXT`
| ) |  |

Called by the client application to request data from the server.

Causes the server connection's OnRequest() member to be called.

Returns
  A character string (actually a pointer to the connection's buffer) if successful, nullptr otherwise.

## ◆ StartAdvise()

bool wxDDEConnection::StartAdvise | ( | const wxString & | item | ) |

Called by the client application to ask if an advise loop can be started with the server.

Causes the server connection's OnStartAdvise() member to be called.

Returns
  true if the server okays it, false otherwise.

## ◆ StopAdvise()

bool wxDDEConnection::StopAdvise | ( | const wxString & | item | ) |

Called by the client application to ask if an advise loop can be stopped.

Causes the server connection's OnStopAdvise() member to be called.

Returns
  true if the server okays it, false otherwise.